image: tmaier/docker-compose:latest

# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
  DOCKER_HOST: tcp://docker:2375/
  PY_IPFS_CLUSTER_DEFAULT_ADDR: /dns4/docker/tcp/9094/http
  DOCKER_TLS_CERTDIR: ''

# Pip's cache doesn't store the python packages
# https://pip.pypa.io/en/stable/reference/pip_install/#caching
#
# If you want to also cache the installed packages, you have to install
# them in a virtualenv and cache it as well.
cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .cache/pip
    - venv/

stages:
  - test
  - run
  - pages

before_script:
  - apk add python3
  - python3 -V  # Print out python version for debugging
  - pip3 install virtualenv
  - virtualenv venv
  - source venv/bin/activate

test:
  services:
    - docker:dind
  tags:
    - privileged
  before_script:
    - docker info
    - "docker-compose up &"
    - apk add python3
    - mkdir -p ~/ipfs/ipfs-cluster
    - python3 -V  # Print out python version for debugging
    - pip3 install virtualenv
    - virtualenv venv
    - source venv/bin/activate
  after_script:
    - docker-compose down
  stage: test
  script:
    - pip install -r requirements.txt
    - pip install --upgrade .
    - pip install pytest coverage
    #- tail -F /dev/null
    - coverage run --source=ipfscluster -m pytest
    - coverage html
    - coverage report -m
  coverage: '/TOTAL.+ ([0-9]{1,3}%)/'
  artifacts:
    paths:
      - htmlcov

run:
  stage: run
  script:
    - python3 setup.py bdist_wheel
    - pip3 install dist/*
  artifacts:
    paths:
      - dist/*.whl

pages:
  stage: pages
  script:
    - pip3 install sphinx sphinx_bootstrap_theme sphinxcontrib-napoleon
    - cd docs ; make html
    - mv _build/html/ ../public/
  artifacts:
    paths:
      - public
  only:
    - master
